
' Hardware:
' Start der Uhr durch Reset- Taster
' Takt durch externen Quarzoszillator mit 3,6864 MHz an PB3
' Buzzer an PB 4
' Halb-Stundenvorwahl (Startzeit) durch 3 Schalter an PB0, PB1, PB2 jeweils gegen Masse
'
' Quarztakt mit Clkpr auf 3,686400 / 32 herabgesetzt
' -> Timer alle 2 sec;
'
'----------------------------------------------------------

$regfile = "attiny13.dat"
$crystal = 115200                                           ' 3,86 MHz / 32


$hwstack = 32
$swstack = 0
$framesize = 0

On Timer0 Ontimer0                                          'Interrupt-Routine


'Variablen

Dim T As Word                                               ' jeweils 2 Sekunden
Dim Q As Byte                                               ' aufsummierte Halbstunden
Dim V As Byte                                               ' Halbstunden fr Gongausgabe
Dim H As Byte                                               ' Stunden
Dim N As Byte                                               ' wird in Zhlschleife verwendet


' Konstanten

Const Dit1 = 40                                             ' Laenge Sound
Const Dit2 = 25
Const Tonhoehe1 = 12
Const Tonhoehe2 = 16



' Register

Acsr.7 = 1                                                  ' Analog-Komparator ausschalten, spart etwas Strom
Sreg.7 = 1                                                  ' Global Interrupt Enable
Ddrb = &B0001_0000                                          ' alle Pins Eingang bis auf PB4
Portb = &B0000_1111                                         ' alle Pins Pullup-Widerstand bis auf PB4


'----------------------------------------------------------

'
' Timer 0 macht 0,5 Interrupt / sec:
Config Timer0 = Timer , Prescale = 1024
Enable Timer0
Start Timer0

Buzzer Alias Portb.4

Clkpr = &B10000000                                          ' nderung Clockteiler vorbereiten
Clkpr = &B00000101                                          ' 9600000 / 64
Clkpr = &B10000101


                                                            ' Startzeit mit Dip- Schalter vorwhlen; Raster: 30 min
Q = Not Pinb                                                ' Invertieren, da gesetzter Schalter -> 0
Q = Q And &B000_0111                                        ' Bit 0 bis 2 filtern  ->  Q = 1 ... 7
If Q = 0 Then
   Q = 8
End If

Goto Einsprung:


Do                                                          'Hauptschleife

'     If T > 14 Then                                         ' Testbetrieb 30 sek statt 30 min
    If T > 899 Then                                         ' Realbetrieb halbe Stunde ist um
        T = 0
        Incr Q                                              '
        If Q > 8 Then                                       ' Wachwechsel; Uhr auf 00 stellen
           Q = 1
        End If

Einsprung:

       H = Q / 2                                            ' Stunden =  aufsummierte Halbstunden / 2
       V = Q Mod 2                                          ' Rest Stunden


' auszugebende Gongschlaege:


        If V = 1 Then                                       ' Halbe Stunde
           Gosub Gong
        End If

        Wait 1

        For N = 1 To H                                      ' volle Stunden

           Gosub Gong
           Waitms 200
           Gosub Gong
           Waitms 800
        Next

     End If

     Idle

Loop



Gong:

          Sound Buzzer , Dit1 , Tonhoehe1
          Sound Buzzer , Dit2 , Tonhoehe2

Return





'----------------------------------------------------------


Ontimer0:                                                   'Timer1-Overflow-Interrupt-Routine

   Tcnt0 = 31                                               ' Preset auf 31, damit er 225 Takte bis Ueberlauf zhlt
   Incr T                                                   ' also Interrupt alle 2 Sekunden
Return